// tscat.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <stdlib.h>
#include <stdio.h>
#include <memory.h>
#include <string.h>

//#define __DEBUG__

#define F_SIZE		(10*1024*1024)
#define PACKET_SIZE	(188)




FILE *fpin;
FILE *fpout;
__int64 readsize;
unsigned char buf[F_SIZE];
unsigned char lastGopHeaderBuf[PACKET_SIZE];


/*********************************************/
void printPacket( unsigned char *buf )
{
#ifdef __DEBUG__
	printf( "packet : %02X %02X %02X %02X  :  %02X %02X %02X %02X\n" ,
		 buf[0] , buf[1] , buf[2] , buf[3] ,
		 buf[23] , buf[24] , buf[25] , buf[26] );
#endif
}

/*********************************************/
int  checkHeader( unsigned char *b )
{
	if (*b != 0x47)
		return( 1 );

	return( 0 );
}

/*********************************************/
int  checkGOPheader( unsigned char *b )
{
/* 47 41 */
/* 00 00 01 B3 */
	int pos = 4;
	int i;

	if (*(b + 0) != 0x47 ) return( 1 );
	if (((*(b + 1)) & 0x40) != 0x40 ) return( 1 );

	//ʏTSt@Cł肷悤ɕύX
	if(((*(b + 3)) & 0x20) == 0x20)
		pos += (*(b + 4) + 1);
	if(memcmp((b + pos),"\x00\x00\x01",3) == 0 && (*(b + pos + 3) & 0xf0) == 0xe0) {
		for(i = pos + 9 + 5;i < PACKET_SIZE - 4;i++) {
			if(memcmp(b + i,"\x00\x00\x01\xb3",4) == 0) {
				return( 0 );
			}
		}
	}

	return( 1 );
}

/*********************************************/
void m2tOpen( char *name )
{
	fpin = fopen( name , "rb" );
	if (fpin == NULL) {
		printf( "file cannot open : %s\n" , name );
	}
}

/*********************************************/
void m2tClose( char *name )
{
	fclose( fpin );
}

/*********************************************/
void m2tSearchGOP( char *name , unsigned char *buf ,unsigned char *lastbuf)
{
	int i;
	int num;

	for (i = 0 ; ; i++ ) {
		num = fread( buf , 1 , PACKET_SIZE , fpin );
		readsize += (__int64)num;
		if (num <= 0) {
			printf( "%s : no GOP\n" , name );
			exit( 10 );
		}
		if (checkHeader( buf ) != 0) {
			printf( "%s : not correct m2t data : packet[%X] : size[%X]\n" ,
				name , i , i*PACKET_SIZE );
			exit( 10 );
		}
		if (checkGOPheader( buf ) == 0) {
			if(memcmp(buf,lastbuf,PACKET_SIZE) == 0)	//Ot@C̏In_n߂
				break;
		}
	}
	//fseek( fpin , - PACKET_SIZE , SEEK_CUR );

#ifdef __DEBUG__
	printf( "%s : hit GOP Header : packet[%X] : size[%X]\n" ,
				name , i , i*PACKET_SIZE );
#endif
}


/*********************************************/
int m2tReadGOP( char *name , unsigned char *buf)
{
	int i = 0;
	int num;

	//ŏ1͐擪ǂݍ
	if(lastGopHeaderBuf[0] != 0x00) {
		buf += PACKET_SIZE;
		i++;
	}

	for (; ; i++ , buf += PACKET_SIZE ) {
		num = fread( buf , 1 , PACKET_SIZE , fpin );
		readsize += (__int64)num;
		if (num <= 0) {
			return( 0 );
		}
		if (checkHeader( buf ) != 0) {
			printf( "%s : not correct m2t data : packet[%X] : size[%X]\n" ,
				name , i , i*PACKET_SIZE );
			exit( 10 );
		}
		if (checkGOPheader( buf ) == 0) {
			break;
		}
	}
	//fseek( fpin , - PACKET_SIZE , SEEK_CUR );	fseek2Gȏ̃t@CłȂ

#ifdef __DEBUG__
	printf( "%s : hit GOP Header : packet[%X] : size[%X]\n" ,
				name , i , i*PACKET_SIZE );
#endif
				
	return( i*PACKET_SIZE );
}

/*********************************************/
void m2tOutput( char *inFile , char *outFile , FILE *fpout )
{
	int size;
	int num;
	__int64 total;
	int n;

	m2tOpen( inFile );
	if(fpin == NULL)
		return;
	readsize = 0l;
	_fseeki64(fpin,0l,SEEK_END);
	total = _ftelli64(fpin);
	_fseeki64(fpin,0l,SEEK_SET);
	fprintf(stderr,"%s\n",inFile);
	//ŏ̃t@C͍ŏo͂B
	if(lastGopHeaderBuf[0] != 0x00)
		m2tSearchGOP( inFile , buf , lastGopHeaderBuf);
	for (;;) {
		size = m2tReadGOP( inFile , buf);
		n = (int)((10000*readsize)/total);
		fprintf(stderr, "\rprocessing: %2d.%02d%%", n/100, n%100);
		if (size <= 0)
			break;

		num = fwrite( buf , 1 , size , fpout );
		if (num != size) {
			printf( "file write error : %s\n" , outFile );
			exit( 5 );
		}
		memmove(buf,&buf[size],PACKET_SIZE);
		memcpy(lastGopHeaderBuf,buf,PACKET_SIZE);	//t@C̍Ō(Ȃ)GOPwb_[̃t@C̊JnGOPwb_[ƂċLĂ
	}
	fprintf(stderr,"\n");
	m2tClose( inFile );
}

/*********************************************/
int _tmain(int argc, _TCHAR* argv[])
{
	int i;
	char *outFile;


	if (argc < 3) {
	printf( "This program connects some ts files per GOP.(ver1.00)\n" );
	printf( "usage: [outputfile] [inputfile1] [inputfile2] ...\n" );
		exit( 10 );
	}
	outFile = argv[1];
	
	fpout = fopen( outFile , "wb" );
	if (fpout == NULL) {
		printf( "file cannot create : %s\n" , outFile );
	}

	lastGopHeaderBuf[0] = 0x00;

	for ( i = 2 ; i < argc ; i++ ) {
		m2tOutput( argv[i] ,outFile , fpout );
	}
	
	fclose( fpout );

	return( 0 );
}

